#! /usr/bin/lua

-- simple example of a window with one button that is destoyed when clicked.

require "gtk2"

-- destroy the button on click
function destroy_button(button)
  button:destroy()
end


gtk.init(nil, nil)
win = gtk.window_new(gtk.GTK_WINDOW_TOPLEVEL)
win:set_title("Button Demo")
win:connect('destroy', function() gtk.main_quit() end)
win:show()

-- a button that will destroy itself when clicked.
button = gtk.button_new_with_label("Click me")
win:add(button)
button:show()
button:connect('clicked', destroy_button)

gtk.main()

-- optional but doesn't hurt:
gtk.close()

