#! /usr/bin/lua

-- exercise reference counting

require "gtk2"

gtk.init(nil, nil)

-- Does this leak memory?  Apparently not.  Don't try this with window_new(),
-- as this is a special case (see documentation for GtkObject)
if true then
	for i = 1, 100 do
		btn = gtk.button_new_with_label("Hello")
	end
end
collectgarbage()

function myclick(btn)
	print("hello button ", btn)
end

function build_ui()
	-- wait for user input so the memory can be examined
	local win = gtk.window_new(gtk.GTK_WINDOW_TOPLEVEL)
	local btn = gtk.button_new_with_label("Close")
	win:add(btn)
	win:connect('destroy', gtk.main_quit)
	-- btn:connect('clicked', gtk.main_quit)
	btn:connect('clicked', myclick)
	win:show_all()
end


build_ui()
gtk.main()


gtk.close()

