
struct struct_info {
	short	name_ofs;
	short	elem_start;
	short	elem_count;
	short	struct_size;		/* total size in bytes */
};
extern const struct struct_info struct_list[];

struct struct_elem {
	int	name_ofs;		/* ofs in struct_strings; short is enough */
	short	bit_offset;
	short	bit_length;
	short	type_detail;		/* if it is a substructure, struct nr */
	char	type;
	char	pad;
};
extern const struct struct_elem elem_list[];
extern const int struct_count;
extern const char struct_strings[];


/*
struct struct_elem {
	char *name;
	short bit_offset;
	short bit_length;
	short type_detail;
	char type;
};
	
struct struct_info {
	char *name;
	short elem_start;
	short elem_count;
};
*/

/* arg types that need special handling */
/* instead of this, I could use the GTK_VALUE_xxx and GTK_RETLOC_xxx
 * constants.  See gtktypeutils.h */
enum ArgType {
    AT_VOID = 0,
    AT_LONG,
    AT_WIDGET,
    AT_BOOL,
    AT_STRING,
    AT_POINTER,
    AT_DOUBLE,
    AT_VARARG,
    AT_VALIST,
    AT_LONGPTR,
    AT_STRUCTPTR,
    AT_STRUCT,
};


struct ffi_type_map_t {
	const char *name;
	int	with_struct;		/* may go away in the future */
	enum ArgType at;
	void	*type;
};
// extern const struct ffi_type_map_t ffi_type_map[];


