const struct ffi_type_map_t ffi_type_map[] = {
  { "VARARG", 0, AT_VARARG, NULL },
  { "STRUCTPTR", 1, AT_STRUCTPTR, &ffi_type_pointer },
  { "ENUM", 0, AT_LONG, &ffi_type_uint },
  { "FUNC", 0, AT_POINTER, &ffi_type_pointer },
  { "STRUCT", 1, AT_STRUCT, NULL },
  { "STRUCTPTRPTR", 1, AT_POINTER, &ffi_type_pointer },
  { "FUNCPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "LONGLONG", 0, AT_LONG, &ffi_type_ulong },
  { "ENUMPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "LONG", 0, AT_LONG, &ffi_type_uint },
  { "LONGPTR", 0, AT_LONGPTR, &ffi_type_pointer },
  { "WIDGET", 1, AT_WIDGET, &ffi_type_pointer },
  { "WIDGETPTR", 1, AT_POINTER, &ffi_type_pointer },
  { "STRUCTPTRPTRPTR", 1, AT_POINTER, &ffi_type_pointer },
  { "ENUMPTRPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "VOIDPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "STRING", 0, AT_STRING, &ffi_type_pointer },
  { "VOID", 0, AT_VOID, &ffi_type_void },
  { "STRINGPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "STRINGPTRPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "DOUBLE", 0, AT_DOUBLE, &ffi_type_double },
  { "BOOL", 0, AT_BOOL, &ffi_type_uint },
  { "BOOLPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "DOUBLEPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "LONGPTRPTR", 0, AT_POINTER, &ffi_type_pointer },
  { "VOIDPTRPTR", 0, AT_POINTER, &ffi_type_pointer },
};
